| Qore DataProvider Module Reference 2.7.1

Public Member Functions | Public Attributes | Protected Member Functions | Static Protected Member Functions | List of all members
DataProvider::NullDataProvider Class Reference

A dumrequest data provider that provides an empty hash as the request and response types. More...

Inheritance diagram for DataProvider::NullDataProvider:
[legend]

## Public Member Functions
| constructor (*hash< auto > options)
| Creates the object.
*string | getDesc ()
| Returns the data provider description.
string | getName ()
| Returns the name of this data provider (`"NullRequest"`)
hash< DataProviderInfo > | getStaticInfoImpl ()
| Returns data provider static info.
Public Member Functions inherited from DataProvider::AbstractDataProvider
| addField (AbstractDataField field, *hash< auto > field_add_options)
| Creates a new field. More...
| beginTransaction ()
| Begins a transaction with a data provider. More...
| checkAddField ()
| Ensures that the data provider supports adding fields. More...
| checkCreate ()
| Ensures that the data provider supports record creation. More...
| checkCreateChild ()
| Ensures that the data provider supports creating children. More...
| checkDelete ()
| Ensures that the data provider supports record deletion. More...
| checkDeleteChild ()
| Ensures that the data provider supports deleting children. More...
| checkDeleteField ()
| Ensures that the data provider supports deleting fields. More...
| checkMessages ()
| Ensures that the data provider supports sending messages. More...
| checkObservable ()
| Ensures that the data provider supports observer pattern / event API. More...
| checkRead ()
| Ensures that the data provider supports read operations. More...
| checkRequest ()
| Ensures that the data provider supports the request API. More...
| checkSchema ()
| Ensures that the data provider supports a schema. More...
| checkSearchExpressions ()
| Ensures that the data provider supports advanced search expressions. More...
| checkUpdate ()
| Ensures that the data provider supports record upserts. More...
| checkUpdateField ()
| Ensures that the data provider supports updating fields. More...
| checkUpsert ()
| Ensures that the data provider supports record upserts. More...
| commit ()
| Commits data written to the data provider. More...
| constructor ()
| Creates the data provider.
| constructor (Logger logger)
| Creates the data provider with the given Logger.
AbstractDataProvider | createChildProvider (string name, hash< string, AbstractDataField > fields, *hash< auto > child_create_options)
| Creates a new child data provider and returns it after adding as a child. More...
*hash< auto > | createRecord (hash< auto > rec, *hash< auto > create_options)
| Creates the given record in the data provider. More...
| deleteChildProvider (string name, *hash< auto > child_delete_options)
| Deletes a child data provider. More...
| deleteField (string name, *hash< auto > field_delete_options)
| Deletes an existing field. More...
int | deleteRecords (*hash< auto > where_cond, *hash< auto > search_options)
| Deletes zero or more records. More...
int | deleteRecords (*hash< DataProviderExpression > where_cond, *hash< auto > search_options)
| Deletes zero or more records. More...
auto | doRequest (auto req, *hash< auto > request_options)
| Makes a request and returns the response. More...
AbstractDataProviderBulkOperation | getBulkInserter ()
| Returns a bulk insert operation object for the data provider. More...
AbstractDataProviderBulkRecordInterface | getBulkRecordInterface (int block_size=1000, *hash< auto > search_options)
| Returns an iterator iterating all records with the bulk read API. More...
AbstractDataProviderBulkOperation | getBulkUpserter ()
| Returns a bulk upsert operation object for the data provider. More...
*AbstractDataProvider | getChildProvider (string name)
| Returns the given child provider or NOTHING if the given child is unknown. More...
AbstractDataProvider | getChildProviderEx (string name)
| Returns the given child provider or throws an exception if the given child is unknown. More...
*list< string > | getChildProviderNames ()
| Returns a list of child data provider names, if any. More...
AbstractDataProvider | getChildProviderPath (string path)
| Returns the given child provider from a `"/"` separated path string. More...
*list< hash< DataProviderSummaryInfo > > | getChildProviderSummaryInfo ()
| Return data provider summary info. More...
*string | getDesc ()
| Returns the data provider description.
private hash< DataProviderExpression > | getEqualityComparisonExpression (int role, hash< DataProviderInfo > info, string key, auto value)
| Returns an equality comparison expression. More...
AbstractDataProviderType | getErrorResponseType (string error_code)
| Returns the type for the given error code. More...
*hash< string, AbstractDataProviderType > | getErrorResponseTypes ()
| Returns a hash of error responses, if any. More...
hash< DataProviderMessageInfo > | getEventInfo (string event_id)
| Returns the description of an observable event, if any. More...
hash< string, hash< DataProviderMessageInfo > > | getEventTypes ()
| Returns a hash of all supported event types. More...
hash< DataProviderInfo > | getInfo ()
| Returns data provider info.
hash< auto > | getInfoAsData (*bool with_type_info)
| Returns static provider information as data; no objects are returned. More...
*hash< string, hash< MapperRuntimeKeyInfo > > | getMapperRuntimeKeys ()
| Returns custom data mapper runtime keys. More...
hash< DataProviderMessageInfo > | getMessageInfo (string message_id)
| Returns the description of an outbound message, if any. More...
hash< string, hash< DataProviderMessageInfo > > | getMessageTypes ()
| Returns a hash of all supported outbound messages. More...
AbstractDataProviderRecordIterator | getRecordIterator (*hash< auto > search_options)
| Returns an iterator iterating all records. More...
*AbstractDataProviderType | getRequestType ()
| Returns the description of a successful request message, if any. More...
*AbstractDataProviderType | getResponseType ()
| Returns the description of a response message, if this object represents a response message. More...
object | getSchemaObject ()
| Returns the schema supporting this data provider. More...
*hash< auto > | getSearchExpression (*hash< auto > where_cond, *hash< auto > search_options)
| Returns a search expression for a standard search hash. More...
private hash< DataProviderExpression > | getSimpleArgumentIntern (int role, hash< DataProviderInfo > info, hash< DataProviderExpressionInfo > expinfo, string key, auto value)
| Returns an argument for an expression. More...
hash< DataProviderSummaryInfo > | getSummaryInfo ()
| Return data provider summary info.
AbstractDataProviderRecordIterator | requestSearchRecords (auto req, *hash< auto > where_cond, *hash< auto > search_options)
| Returns an iterator for zero or more records matching the search options according to an API request. More...
AbstractDataProviderRecordIterator | requestSearchRecords (auto req, *hash< DataProviderExpression > where_cond, *hash< auto > search_options)
| Returns an iterator for zero or more records matching the search options according to an API request. More...
bool | requiresTransactionManagement ()
| Returns True if the data provider supports transaction management. More...
| rollback ()
| Rolls back data written to the data provider. More...
*hash< auto > | searchFirstRecord (hash< auto > where_cond, *hash< auto > search_options)
| Returns the first record matching the search options. More...
*hash< auto > | searchFirstRecord (hash< DataProviderExpression > where_cond, *hash< auto > search_options)
| Returns the first record matching the search options. More...
AbstractDataProviderRecordIterator | searchRecords (*hash< auto > where_cond, *hash< auto > search_options)
| Returns an iterator for zero or more records matching the search options. More...
AbstractDataProviderRecordIterator | searchRecords (*hash< DataProviderExpression > where_cond, *hash< auto > search_options)
| Returns an iterator for zero or more records matching the search options. More...
AbstractDataProviderBulkRecordInterface | searchRecordsBulk (int block_size=1000, *hash< DataProviderExpression > where_cond, *hash< auto > search_options)
| Returns an iterator for zero or more records matching the search options. More...
AbstractDataProviderBulkRecordInterface | searchRecordsBulk (int block_size=1000, *hash< auto > where_cond, *hash< auto > search_options)
| Returns an iterator for zero or more records matching the search options. More...
*hash< auto > | searchSingleRecord (hash< auto > where_cond, *hash< auto > search_options)
| Returns a single record matching the search options. More...
*hash< auto > | searchSingleRecord (hash< DataProviderExpression > where_cond, *hash< auto > search_options)
| Returns a single record matching the search options. More...
| sendMessage (string message_id, auto msg, *hash< auto > send_message_options)
| Sends a message from message-capable data providers. More...
| setLogger (Logger logger)
| Sets or replaces the logger.
| updateField (string name, AbstractDataField field, *hash< auto > field_update_options)
| Updates an existing field. More...
int | updateRecords (hash< auto > set, *hash< auto > where_cond, *hash< auto > search_options)
| Updates zero or more records matching the search options. More...
int | updateRecords (hash< auto > set, *hash< DataProviderExpression > where_cond, *hash< auto > search_options)
| Updates zero or more records matching the search options. More...
bool | updateSingleRecord (hash< auto > set, hash< auto > where_cond, *hash< auto > search_options)
| Updates a single record matching the search options. More...
bool | updateSingleRecord (hash< auto > set, hash< DataProviderExpression > where_cond, *hash< auto > search_options)
| Updates a single record matching the search options. More...
string | upsertRecord (hash< auto > rec, *hash< auto > upsert_options)
| Upserts the given record in the data provider. More...

## Public Attributes
const | ProviderInfo
| Provider info.
Public Attributes inherited from DataProvider::AbstractDataProvider
const | DataProviderSummaryInfoKeys = map $1.getName()
| A list of members names of the DataProviderSummaryInfoKeys hashdecl.
const | GenericExpressionImplementations
| Generic expression implementations for data providers without native search functionality.
const | GenericExpressions = map {$1.key: $1.value.exp}
| Generic search operator expressions. More...

## Protected Member Functions
auto | doRequestImpl (auto req, *hash< auto > request_options)
| Returns an empty hash.
*hash< string, AbstractDataProviderType > | getErrorResponseTypesImpl ()
| Returns NOTHING.
*AbstractDataProviderType | getRequestTypeImpl ()
| Returns an empty hash type.
*AbstractDataProviderType | getResponseTypeImpl ()
| Returns an empty hash type.

## Static Protected Member Functions
static HashDataType | type ()
| The default request and response type for this data provider.

## Additional Inherited Members
Static Public Member Functions inherited from DataProvider::AbstractDataProvider
static auto | evalGenericExpressionValue (hash< auto > rec, auto val)
| Evaluates the given expression with the generic internal implementation and returns the result. More...
static private hash< DataProviderExpressionInfo > | getExpression (int role, string exp, *hash< string, hash< DataProviderExpressionInfo >> expmap)
| Returns an expression definition for an expression code or throws an exception. More...
static bool | setDynamicValueCallbacks ()
| Ensures that no callbacks can be set for dynamic URI resolution. More...
Protected Attributes inherited from DataProvider::AbstractDataProvider
const | GenericRecordSearchOptions
| Generic record search options; see details below. More...
*Logger | logger
| Logger for logging.
Static Protected Attributes inherited from DataProvider::AbstractDataProvider
static bool | callbacks_locked = False
| flag if callbacks are locked
static code | cb_resolve_value
| static callback for dynamic value resolution
static code | cb_value_needs_resolution
| static callback the returns a bool if the value needs dynamic resolution

## Detailed Description

A dumrequest data provider that provides an empty hash as the request and response types.